#include <stdint.h>
#include <avr/io.h>

#include "hwspi.h"
//#include "spi_drv.h" 

// initialize the UART in SPI-compatible mode. For now, we use single-rate mode
// with a clock speed of about 0.5Mbaud
void 			initSPI(void)
{	
	
	/*Spi_set_mode(SPI_MASTER_MODE_3);
	//Spi_set_mode(SPI_MASTER_MODE_0);
   //Spi_set_rate(SPI_RATE_0);   //impossible in AVR mode in spi_drv.h
   Spi_config_speed(SPI_RATE_3); //theses 2 lines replace the Spi_set_rate(SPI_RATE_0)
   //Spi_set_doublespeed();        //theses 2 lines replace the Spi_set_rate(SPI_RATE_0)
   // Spi_set_rate(SPI_RATE_0) -> SCK freq == fosc/2.
   // ==
   // Spi_config_speed(SPI_RATE_1) -> SCK freq == fosc/4
   // +
   // Spi_set_doublespeed() -> SCK freq == fosc/2

   Spi_disable_ss();
   Spi_enable();*/
	 
	//DDR_SPI |= (1<<PIN_MOSI) | (1<<PIN_SCK) | (1<<PIN_SS);
	//PORTR_SPI |= (1<<PIN_SS);
	//PORTR_SPI &= ~((1<<PIN_MOSI) | (1<<PIN_MISO) | (1<<PIN_SCK));
	//DDR_RESET |= (1<<PIN_RESET);
	//PORTR_RESET &= ~(1<<PIN_RESET);
	//UBRR1 = 0;
	//DDRB |= (1<<0x00)|(1<<0x01)|(1<<0x02);
	/*UCSR1C = (1<<UMSEL11)|(1<<UMSEL10);
	UCSR1B = (1<<RXEN1)|(1<<TXEN1);
	UCSR1A = 0;
	UBRR1 = 4;*/
	
#define MSK_SPI_MODE      	0x0C
#define MSK_SPI_ENABLE		0x40
#define MSK_SPI_MASTER_MODE	0x10
#define MSK_MSTR                0x10
#define SPI_MASTER_MODE_0 (MSK_MSTR)
#define SPI_MASTER_MODE_1 (MSK_MSTR|0x04)
#define SPI_MASTER_MODE_2 (MSK_MSTR|0x08)
#define SPI_MASTER_MODE_3 (MSK_MSTR|0x0C)
	
	SPCR &= ~(MSK_SPI_MASTER_MODE|MSK_SPI_MODE ); 
	SPCR |= SPI_MASTER_MODE_0;
	DDRB |= (1<<DDB2)|(1<<DDB1)|(1<<DDB0);
	
#define MSK_SPI_SPR1  0x02
#define MSK_SPI_SPR0  0x01
//#define SPI_RATE_0        0x00    /* Fper / 2 */
#define SPI_RATE_1        0x00    /* Fper / 4 */
//#define SPI_RATE_2        0x02    /* Fper / 8 */
#define SPI_RATE_3        0x01    /* Fper / 16 */
//#define SPI_RATE_4        0x80    /* Fper / 32 */
#define SPI_RATE_5        0x02    /* Fper / 64 */
#define SPI_RATE_6        0x03    /* Fper / 128 */
	SPCR &= ~(MSK_SPI_SPR1|MSK_SPI_SPR0);
	SPCR |= SPI_RATE_3;
	
	SPCR |=MSK_SPI_ENABLE;
}

uint8_t 	spiTransfer(uint8_t n_data)
{
	//PORTB &= ~(0x01);	// slave selected
	//Spi_write_data(n_data);
	//PORTB |= 0x01;		// slave deselected
	//return Spi_read_data();
	SPDR = n_data;
	while(~SPSR & (1<<SPIF));
	n_data = SPDR;
	return n_data;
}

void ResetSPI(void)
{
	// due to the xxx! SPI slave implementation of the MSP, we need to 
	// toggle a pin from time to time that serves as an indicator that
	// the bus is free and that it's time to reset the slave SPI controller
	PORTB &= ~(0x01);	// slave selected
	stupiddelay();
	PORTB |= 0x01;		// slave deselected
	stupiddelay();		// allow some time to initialize the SPI
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
	stupiddelay();
}

void stupiddelay(void)
{
	uint8_t temp = resp_timeout;

	for (; temp--;);
}
